#!/bin/bash
# only support systemd linux ,such as ubuntu 18 , open KylinOS ,centos......
echo 
echo "Now will install Xfilesvr service in this computer"
echo "Test on Ubuntu linux and open KylinOS system"
echo "You must edit /usr/tmp1/Xfile/myaccount.ini and /usr/tmp1/Xfile/myshare.txt before you start service"
echo " "
echo 

if [ `whoami` != 'root' ]; then
    echo "Please run this shellscript under root account. "
    exit 0
fi

if [ ! -f ./Xfilesvr.service ]; then
    echo "Xfilesvr.service error , install failed"
    exit 0
fi 

if [ ! -d ./config ]; then
   echo "config folder error , install failed"
   exit 0
fi

if [ ! -d /etc/systemd/system ]; then
    echo "Systemd folder not found, install failed"
    exit 0
fi

if [ ! -f ./Xfilesvr ]; then
    echo "Xfilesvr error , install failed"
    exit 0
fi

basepath=$(cd `dirname $0`; pwd)
echo $basepath
if [ $basepath = "/usr/tmp1/Xfile" ]; then
    echo "Error: You are running install script under object folder"
    exit 0
fi


echo "File and folder check ok, now will try to install"




if [ -f /etc/systemd/system/Xfilesvr.service ]
then
    echo "Found Xfilesvr already installed, will try to stop it"
    sudo systemctl stop Xfilesvr.service
else
    sudo cp ./Xfilesvr.service /etc/systemd/system/Xfilesvr.service 
fi

gchoice=0
echo $gchoice
echo "Do you want to enable Xfilesvr auto start with system boot?"
select var in "No" "Yes"; do
  if [ "$var" = "Yes" ]; then
      gchoice=1
      break
  else
      break
  fi
done

#echo $var 
if [ $gchoice -eq 1 ]; then
    echo "Enable xfile service to auto start with system boot"
    sudo systemctl enable Xfilesvr.service
fi

if [ ! -d /usr/tmp1 ]
then
  echo "Now will try to create /usr/tmp1 and copy all files"
  sudo mkdir /usr/tmp1
  sudo mkdir /usr/tmp1/Xfile
  sudo cp ./Xfilesvr /usr/tmp1/Xfile/
  sudo chmod +x /usr/tmp1/Xfile/Xfilesvr
  sudo mkdir /usr/tmp1/Xfile/config
  sudo cp ./config/*.* /usr/tmp1/Xfile/config/
elif [ ! -d /usr/tmp1/Xfile ] 
then
   echo "Now will try to create /usr/tmp1/Xfile and copy all files"
   sudo mkdir /usr/tmp1/Xfile
   sudo cp ./Xfilesvr /usr/tmp1/Xfile/
   sudo chmod +x /usr/tmp1/Xfile/Xfilesvr
   sudo mkdir /usr/tmp1/Xfile/config
   sudo cp ./config/*.* /usr/tmp1/Xfile/config/
elif [ ! -d /usr/tmp1/Xfile/config ]
then
    echo "Now will try to create config folder, and copy files"
    sudo mkdir /usr/tmp1/Xfile/config
    sudo cp ./config/*.* /usr/tmp1/Xfile/config/
    sudo cp -f ./Xfilesvr /usr/tmp1/Xfile/
    sudo chmod +x /usr/tmp1/Xfile/Xfilesvr
else
    echo "Found folder already exist, will only upgrade server program"
    sudo cp -f ./Xfilesvr /usr/tmp1/Xfile/
    sudo chmod +x /usr/tmp1/Xfile/Xfilesvr 
fi

##need to add defalut pem file , if not exist

if [ ! -f /usr/tmp1/Xfile/config/sslcert.pem ]
then
    sudo cp ./config/sslcert.pem /usr/tmp1/Xfile/config/
     
fi

if [ ! -f /usr/tmp1/Xfile/config/sslkey.pem ]
then
    sudo cp ./config/sslkey.pem /usr/tmp1/Xfile/config/ 
fi

## All done

echo "********************"
echo "Install done"
echo "You must edit /usr/tmp1/Xfile/config/myaccount.ini and /usr/tmp1/Xfile/config/myshare.txt before run"
echo "Use command [ systemctl start Xfilesvr.service ] to start service after you finish the setting file"

echo "www.phoenixp2p.com   www.phoenixp2p.cn"
echo "********************"
exit 1

